;
; cobra patch
; mailto:jp@drumfu.com
; november 2010
;
; patch to original alkatraz version of cobra
; to run on +2A/B/3 et al - changes to avoid port $ff
; as discussed within the WoS forums
; http://www.worldofspectrum.org/forums/showthread.php?t=25273
;
; original release:
;
;	org $95fe
;	ld bc, $3f28		 ; 95fe 01 28 3f $0ats
;l_9601	ld a, c			 ; 9601 79 $04ts
;	in a, ($ff)		 ; 9602 db ff $0bts
;	cp b			 ; 9604 b8 $04ts
;	jr nc, l_9601		 ; 9605 30 fa $07/$0cts
;	ret			 ; 9607 c9 $0ats
;
; hit squad release:
;
;	org $95fe
;	ld bc, $0300		 ; 95fe 01 00 03 $0ats
;l_9601 dec bc			 ; 9601 0b $06ts
;	ld a, b			 ; 9602 78 $04ts
;	or c			 ; 9603 b1 $04ts
;	nop			 ; 9604 00 $04ts
;	jr nz, l_9601		 ; 9605 20 fa $07/$0cts
;	ret			 ; 9607 c9 $0ats
;
;
; this patch derived from jon north's cobra poke
; found on Your Sinclair Pokes Party Pack
; http://www.worldofspectrum.org/infoseekid.cgi?id=0015575
;
; updated july 2011
; to include bandit's night stalker patch
; and to remove screen corruption during patch
; execution and game loading
; as discussed within the WoS forums
; http://www.worldofspectrum.org/forums/showthread.php?t=34295
;
	org $88b8
;
l_88b8: ld ix, (l_8a53)		 ; 88b8 dd 2a 53 8a $14ts
	ld de, (l_8a55)		 ; 88bc ed 5b 55 8a $14ts
	ld a, $ff		 ; 88c0 3e ff $07ts
	scf			 ; 88c2 37 $04ts
	call $0556		 ; 88c3 cd 56 05 $11ts
	jr nc, l_88b8		 ; 88c6 30 f0 $07/$0cts
	di			 ; 88c8 f3 $04ts
	ld hl, (l_8a57)		 ; 88c9 2a 57 8a $10ts
l_88cc: push hl			 ; 88cc e5 $0bts
	ld a, (hl)		 ; 88cd 7e $07ts
	cp $31			 ; 88ce fe 31 $07ts
	jr z, l_88fc		 ; 88d0 28 2a $0c/$07ts
	cp $3e			 ; 88d2 fe 3e $07ts
	jr nz, l_88dc		 ; 88d4 20 06 $07/$0cts
	ld bc, $000e		 ; 88d6 01 0e 00 $0ats
	pop hl			 ; 88d9 e1 $0ats
	add hl, bc		 ; 88da 09 $0bts
	push hl			 ; 88db e5 $0bts
l_88dc: ld b, $01		 ; 88dc 06 01 $07ts
l_88de: ld a, $20		 ; 88de 3e 20 $07ts
	cpir			 ; 88e0 ed b1 $10/$15ts
	or (hl)			 ; 88e2 b6 $07ts
	jp p, l_88de		 ; 88e3 f2 de 88 $0a/$0ats
	pop de			 ; 88e6 d1 $0ats
	sbc hl, de		 ; 88e7 ed 52 $0fts
	ex de, hl		 ; 88e9 eb $04ts
	ld b, d			 ; 88ea 42 $04ts
	ld c, e			 ; 88eb 4b $04ts
	inc bc			 ; 88ec 03 $06ts
	ld de, $4000		 ; 88ed 11 d8 59 $0ats
	ldir			 ; 88f0 ed b0 $10/$15ts
	push hl			 ; 88f2 e5 $0bts
	ld a, $c9		 ; 88f3 3e c9 $07ts
	ld (de), a		 ; 88f5 12 $07ts
	call $4000		 ; 88f6 cd d8 59 $11ts
	pop hl			 ; 88f9 e1 $0ats
	jr l_88cc		 ; 88fa 18 d0 $0cts
l_88fc: ld bc, $0080		 ; 88fc 01 80 00 $0ats
	add hl, bc		 ; 88ff 09 $0bts
	ld (hl), $c3		 ; 8900 36 c3 $0ats
	ld ($8927), hl		 ; 8902 22 27 89 $10ts
	ld c, $06		 ; 8905 0e 06 $07ts
	add hl, bc		 ; 8907 09 $0bts
	ld ($892f), hl		 ; 8908 22 2f 89 $10ts
	ld c, $99		 ; 890b 0e 99 $07ts
	add hl, bc		 ; 890d 09 $0bts
	ld ($892b), hl		 ; 890e 22 2b 89 $10ts
	ld hl, l_891e		 ; 8911 21 1e 89 $0ats
	ld de, $adad		 ; 8914 11 ad ad $0ats
	ldir			 ; 8917 ed b0 $10/$15ts
	ld hl, l_8931		 ; 8919 21 31 89 $0ats
	exx			 ; 891c d9 $04ts
	ret			 ; 891d c9 $0ats
l_891e: xor ixl			 ; 891e dd ad $08ts
	xor l			 ; 8920 ad $04ts
	ld (ix+$00), a		 ; 8921 dd 77 00 $13ts
	ld a, $c3		 ; 8924 3e c3 $07ts
	ld ($0000), a		 ; 8926 32 00 00 $0dts
	exx			 ; 8929 d9 $04ts
	ld ($0000), hl		 ; 892a 22 00 00 $10ts
	exx			 ; 892d d9 $04ts
	jp $0000		 ; 892e c3 00 00 $0ats
l_8931: ld hl, (l_8a59)		 ; 8931 2a 59 8a $10ts
l_8934: ld ($4010), hl		 ; 8934 22 10 59 $10ts
	ld ix, $0000		 ; 8937 dd 21 00 00 $0ets
	ld b, $00		 ; 893b 06 00 $07ts
	ld a, (hl)		 ; 893d 7e $07ts
	cp $3e			 ; 893e fe 3e $07ts
	jr nz, l_894d		 ; 8940 20 0b $07/$0cts
	ld c, $06		 ; 8942 0e 06 $07ts
	add hl, bc		 ; 8944 09 $0bts
	inc (hl)		 ; 8945 34 $0bts
	ld c, $08		 ; 8946 0e 08 $07ts
	add hl, bc		 ; 8948 09 $0bts
	ld ixl, $0e		 ; 8949 dd 2e 0e $0bts
	ld a, (hl)		 ; 894c 7e $07ts
l_894d: cp $d9			 ; 894d fe d9 $07ts
	jr nz, l_8954		 ; 894f 20 03 $07/$0cts
	inc hl			 ; 8951 23 $06ts
	inc ix			 ; 8952 dd 23 $0ats
l_8954: ld ($4015), hl		 ; 8954 22 15 59 $10ts
	ld c, $0a		 ; 8957 0e 0a $07ts
	add hl, bc		 ; 8959 09 $0bts
	ld a, (hl)		 ; 895a 7e $07ts
	cp $3c			 ; 895b fe 3c $07ts
	jr nz, l_8968		 ; 895d 20 09 $07/$0cts
	ld c, $7b		 ; 895f 0e 7b $07ts
	add ix, bc		 ; 8961 dd 09 $0fts
	ld c, $71		 ; 8963 0e 71 $07ts
	add hl, bc		 ; 8965 09 $0bts
	jr l_8954		 ; 8966 18 ec $0cts
l_8968: cp $cd			 ; 8968 fe cd $07ts
	jr nz, l_896e		 ; 896a 20 02 $07/$0cts
	ld (hl), $21		 ; 896c 36 21 $0ats
l_896e: cp $21			 ; 896e fe 21 $07ts
	jr nz, l_8976		 ; 8970 20 04 $07/$0cts
	ld c, $12		 ; 8972 0e 12 $07ts
	add hl, bc		 ; 8974 09 $0bts
	inc (hl)		 ; 8975 34 $0bts
l_8976: inc hl			 ; 8976 23 $06ts
	inc hl			 ; 8977 23 $06ts
	ld a, (hl)		 ; 8978 7e $07ts
	cp $ae			 ; 8979 fe ae $07ts
	jr nz, l_8981		 ; 897b 20 04 $07/$0cts
	ld c, $0c		 ; 897d 0e 0c $07ts
	add hl, bc		 ; 897f 09 $0bts
	inc (hl)		 ; 8980 34 $0bts
l_8981: ld iy, l_89f1		 ; 8981 fd 21 f1 89 $0ets
l_8985: ld hl, ($4015)		 ; 8985 2a 15 59 $10ts
	ld c, (iy+$00)		 ; 8988 fd 4e 00 $13ts
	add hl, bc		 ; 898b 09 $0bts
	ld a, (hl)		 ; 898c 7e $07ts
	cp (iy+$01)		 ; 898d fd be 01 $13ts
	jr nz, l_899a		 ; 8990 20 08 $07/$0cts
	ld c, (iy+$02)		 ; 8992 fd 4e 02 $13ts
	ld a, (iy+$03)		 ; 8995 fd 7e 03 $13ts
	jr l_89a7		 ; 8998 18 0d $0cts
l_899a: ld c, $04		 ; 899a 0e 04 $07ts
	add iy, bc		 ; 899c fd 09 $0fts
	ld a, (iy+$00)		 ; 899e fd 7e 00 $13ts
	or a			 ; 89a1 b7 $04ts
	jr nz, l_8985		 ; 89a2 20 e1 $07/$0cts
	jp l_8a43		 ; 89a4 c3 43 8a $0ats
l_89a7: add ix, bc		 ; 89a7 dd 09 $0fts
	ld c, ixl		 ; 89a9 dd 4d $08ts
	ld hl, ($4010)		 ; 89ab 2a 10 59 $10ts
	ld de, $40d8		 ; 89ae 11 d8 59 $0ats
	ldir			 ; 89b1 ed b0 $10/$15ts
	ld ($4012), hl		 ; 89b3 22 12 59 $10ts
	ld hl, l_89e5		 ; 89b6 21 e5 89 $0ats
	ld c, $05		 ; 89b9 0e 05 $07ts
	ld ($89e6), a		 ; 89bb 32 e6 89 $0dts
	ldir			 ; 89be ed b0 $10/$15ts
	ld a, ($4014)		 ; 89c0 3a 14 59 $0dts
	ld r, a			 ; 89c3 ed 4f $09ts
	jp $40d8		 ; 89c5 c3 d8 59 $0ats
l_89c8: ld a, r			 ; 89c8 ed 5f $09ts
	rlca			 ; 89ca 07 $04ts
	sub $08			 ; 89cb d6 08 $07ts
	rrca			 ; 89cd 0f $04ts
	ld ($4014), a		 ; 89ce 32 14 59 $0dts
	ld hl, ($4012)		 ; 89d1 2a 12 59 $10ts
	ld a, (hl)		 ; 89d4 7e $07ts
	cp $20			 ; 89d5 fe 20 $07ts
	jr nz, l_89de		 ; 89d7 20 05 $07/$0cts
l_89d9: inc hl			 ; 89d9 23 $06ts
l_89da: inc hl			 ; 89da 23 $06ts
	jp l_8934		 ; 89db c3 34 89 $0ats
l_89de: cp $c2			 ; 89de fe c2 $07ts
	jr nz, l_89da		 ; 89e0 20 f8 $07/$0cts
	inc hl			 ; 89e2 23 $06ts
	jr l_89d9		 ; 89e3 18 f4 $0cts
l_89e5: jr nz, l_89e7		 ; 89e5 20 00 $07/$0cts
l_89e7: jp l_89c8		 ; 89e7 c3 c8 89 $0ats
	dec (hl)		 ; 89ea 35 $0bts
	ld e, a			 ; 89eb 5f $04ts
	ld sp, $0d10		 ; 89ec 31 10 0d $0ats
	dec bc			 ; 89ef 0b $06ts
	rla			 ; 89f0 17 $04ts
l_89f1: dec bc			 ; 89f1 0b $06ts
	jr nz, $89ff		 ; 89f2 20 0b $07/$0cts
	ld sp, hl		 ; 89f4 f9 $06ts
	dec c			 ; 89f5 0d $04ts
	pop hl			 ; 89f6 e1 $0ats
	inc hl			 ; 89f7 23 $06ts
	ret p			 ; 89f8 f0 $05/$0bts
	ld a, (bc)		 ; 89f9 0a $07ts
	ld d, (hl)		 ; 89fa 56 $07ts
	jr $89f3		 ; 89fb 18 f6 $0cts
	ld a, (bc)		 ; 89fd 0a $07ts
	ld hl, $ed1e		 ; 89fe 21 1e ed $0ats
	ld a, (bc)		 ; 8a01 0a $07ts
	dec bc			 ; 8a02 0b $06ts
	dec c			 ; 8a03 0d $04ts
	rst $30			 ; 8a04 f7 $0bts
	ld a, (bc)		 ; 8a05 0a $07ts
	or c			 ; 8a06 b1 $04ts
	dec bc			 ; 8a07 0b $06ts
	ld sp, hl		 ; 8a08 f9 $06ts
	ld a, (bc)		 ; 8a09 0a $07ts
	dec de			 ; 8a0a 1b $06ts
	ld c, $f6		 ; 8a0b 0e f6 $07ts
	ld a, (bc)		 ; 8a0d 0a $07ts
	ld b, $1d		 ; 8a0e 06 1d $07ts
	ex de, hl		 ; 8a10 eb $04ts
	inc c			 ; 8a11 0c $04ts
	defb $fd		 ; 8a12 fd $04ts
	ld a, (de)		 ; 8a13 1a $07ts
	xor $0b			 ; 8a14 ee 0b $07ts
	ld a, b			 ; 8a16 78 $04ts
	ld c, $f6		 ; 8a17 0e f6 $07ts
	inc c			 ; 8a19 0c $04ts
	ld a, b			 ; 8a1a 78 $04ts
l_8a1b: ld c, $f6		 ; 8a1b 0e f6 $07ts
	dec bc			 ; 8a1d 0b $06ts
	or c			 ; 8a1e b1 $04ts
	inc c			 ; 8a1f 0c $04ts
	ret m			 ; 8a20 f8 $0b/$05ts
	ld a, (bc)		 ; 8a21 0a $07ts
	ld d, a			 ; 8a22 57 $04ts
	djnz l_8a1b		 ; 8a23 10 f6 $08/$0dts
	rrca			 ; 8a25 0f $04ts
	dec sp			 ; 8a26 3b $06ts
	inc d			 ; 8a27 14 $04ts
	ret p			 ; 8a28 f0 $05/$0bts
	rrca			 ; 8a29 0f $04ts
	pop bc			 ; 8a2a c1 $0ats
	inc de			 ; 8a2b 13 $06ts
	pop af			 ; 8a2c f1 $0ats
	dec bc			 ; 8a2d 0b $06ts
	dec bc			 ; 8a2e 0b $06ts
	rrca			 ; 8a2f 0f $04ts
	or $0e			 ; 8a30 f6 0e $07ts
	or c			 ; 8a32 b1 $04ts
	rrca			 ; 8a33 0f $04ts
	or $0c			 ; 8a34 f6 0c $07ts
	xor (hl)		 ; 8a36 ae $07ts
	ld a, (de)		 ; 8a37 1a $07ts
	xor $00			 ; 8a38 ee 00 $07ts
	ld d, e			 ; 8a3a 53 $04ts
	or d			 ; 8a3b b2 $04ts
	adc a, b		 ; 8a3c 88 $04ts
	and h			 ; 8a3d a4 $04ts
	add a, h		 ; 8a3e 84 $04ts
	ld h, e			 ; 8a3f 63 $04ts
	ld h, b			 ; 8a40 60 $04ts
	ld e, (hl)		 ; 8a41 5e $07ts
	ld l, d			 ; 8a42 6a $04ts
l_8a43: ld hl, patch		 ; 8a43 21 5d 8a $0ats
	ld de, (l_8a5b)		 ; 8a46 ed 5b 5b 8a $14ts
	ld bc, epatch-patch	 ; 8a4a 01 0c 00 $0ats
	ldir			 ; 8a4d ed b0 $10/$15ts
	ld hl, ($4010)		 ; 8a4f 2a 10 59 $10ts
	jp (hl)			 ; 8a52 e9 $04ts
l_8a53: defw $ec65		 ; 8a53 65 ec ts
l_8a55:	defw $0526		 ; 8a55 26 05 ts
l_8a57: defw $ecf8		 ; 8a57 f8 ec ts
l_8a59:	defw $f14d		 ; 8a59 4d f1 ts
l_8a5b: defw $fbda		 ; 8a5b da fb ts
;
; the offset between where the game is originally
; loaded and then later moved by the routine at
; $5b00
;
off_set	equ $0636		; e.g. $95fe - $8fc8
;
patch	ld hl,hitsqd-patch + $fbda
	ld de,$95fe - off_set
	ld bc,nstalk0-hitsqd
	ldir			; copy port $ff patch
;
	ld hl,nstalk0-patch + $fbda
	ld de, $aef0 - off_set
	ld bc,nstalk1-nstalk0
	ldir			; copy 1st night stalker patch
;
	ld hl,nstalk1-patch + $fbda
	ld de, $956a - off_set
	ld bc,epatch-nstalk1
	ldir			; copy 2nd night stalker patch
;
	ret
;
hitsqd	ld bc, $0300
l_9601	dec bc
	ld a,b
	or c
	nop
	jr nz,l_9601
	ret 
;
nstalk0	call $95b9
	cp $07
	ret z
	jp $956d
;
nstalk1	jp $aef0
;
epatch	equ $
